public class Geobserver <E extends Point2D>
{
  double m_toll = 0;

  public Geobserver(double tollerance)
  {
    m_toll = tollerance;
  }

  private double getSP(double x1, double y1, double x2, double y2)
  {
    return x1 * x2 + y1 * y2;
  }

  private double getModule(double x1, double y1)
  {
    return Math.sqrt(Math.pow(x1, 2) +
                     Math.pow(y1, 2));
  }

  public boolean checkAlignment(E p1, E p2, E p3)
  {
    double x1 = p2.getX() - p1.getX();
    double y1 = p2.getY() - p1.getY();
    double x2 = p3.getX() - p1.getX();
    double y2 = p3.getY() - p1.getY();
    double pm = getModule(x1,y1) * getModule(x2,y2);
    return Math.abs(Math.abs(getSP(x1,y1,x2,y2)) - pm) / pm < m_toll
        && x1 * x2 >= 0 && y1 * y2 >= 0;
  }

  double min = Double.MAX_VALUE;

  public boolean checkRect(E p1, E p2, E p3)
  {
    double x1 = p2.getX() - p1.getX();
    double y1 = p2.getY() - p1.getY();
    double x2 = p3.getX() - p1.getX();
    double y2 = p3.getY() - p1.getY();
    double pm = getModule(x1,y1) * getModule(x2,y2);
    min = Math.min(min, Math.abs(getSP(x1,y1,x2,y2)) / pm / pm);
    return Math.abs(getSP(x1,y1,x2,y2)) / pm / pm < m_toll;
  }

}
