import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.JToggleButton;
import java.io.*;
import java.util.*;

import javax.swing.WindowConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.*;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI
 * Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose
 * whatever) then you should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details. Use of Jigloo implies
 * acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN
 * PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR
 * ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class PlanetFrame extends javax.swing.JFrame 
	implements AlignmentListener{
	private static final long serialVersionUID = 1L;
	private JButton m_save;
	private JButton m_load;
	private JToggleButton m_runStop;
	private JPanel m_buttons;
	private JPanel m_animation;
	
	private Queue<Planet> m_rects = new LinkedList<Planet>();

	public static void main(String[] args) {
		PlanetFrame inst = new PlanetFrame();
		inst.setVisible(true);
	}

	public PlanetFrame() {
		super();
		initGUI();
		for (Planet p : Planet.values())
			m_animation.add(new PlanetCanvas(p));
	    PlanetObserver o = new PlanetObserver(1E-5);
	    for (Planet p : Planet.values())
	      p.addListener(o);
	    o.addListener(this);
	}

	private void initGUI() {
		try {
			BorderLayout thisLayout = new BorderLayout();
			getContentPane().setLayout(thisLayout);

			m_animation = new JPanel(){		
				public void paint(Graphics g)
				{
					super.paint(g);
/*					System.out.println(g.getClipBounds());
					g.setColor(Color.GREEN);
					g.fillRect(0, 0, getWidth(), getHeight());
					g.setColor(Color.white);*/
					synchronized(m_rects)
					{
						while (!m_rects.isEmpty())
						{
							Planet p1 = m_rects.remove();
							Planet p2 = m_rects.remove();
							Planet p3 = m_rects.remove();
							int x1 = PlanetCanvas.getPlanetX(p1, m_animation);
							int y1 = PlanetCanvas.getPlanetY(p1, m_animation);
							int x2 = PlanetCanvas.getPlanetX(p2, m_animation);
							int y2 = PlanetCanvas.getPlanetY(p2, m_animation);
							int x3 = PlanetCanvas.getPlanetX(p3, m_animation);
							int y3 = PlanetCanvas.getPlanetY(p3, m_animation);
							g.drawLine(x1, y1, x2, y2);
							g.drawLine(x1, y1, x3, y3);
						}
					}
				}
			};
			getContentPane().add(m_animation, BorderLayout.CENTER);
			m_animation.setBackground(new java.awt.Color(0, 0, 0));
			m_animation.setLayout(null);
			m_animation.setSize(400, 217);
			//m_animation.setDoubleBuffered(true);
			m_buttons = new JPanel();
			getContentPane().add(m_buttons, BorderLayout.EAST);
			m_buttons.setPreferredSize(new java.awt.Dimension(124, 217));
			{
				m_runStop = new JToggleButton();
				m_buttons.add(m_runStop);
				m_runStop.setText("STOP");
				m_runStop.setSelected(true);
				m_runStop.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent evt) {
						m_runStop.setText(m_runStop.isSelected() ? "STOP": "RUN");
						if (m_runStop.isSelected())
							Planet.go();
						else
							Planet.stop();
					}
				});
				Planet.go();
			}
			{
				m_save = new JButton();
				m_buttons.add(m_save);
				m_save.setText("SAVE");
				m_save.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent evt) {
						JFileChooser fc = new JFileChooser();
						int returnVal = fc.showSaveDialog(null);
			            if (returnVal == JFileChooser.APPROVE_OPTION) 
			            {
						File f = fc.getSelectedFile();
						new SSDOM().save(f.getPath());
			            }
					}
				});
			}
			{
				m_load = new JButton();
				m_buttons.add(m_load);
				m_load.setText("LOAD");
				m_load.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent evt) {
						JFileChooser fc = new JFileChooser();
						int returnVal = fc.showOpenDialog(null);
			            if (returnVal == JFileChooser.APPROVE_OPTION) 
			            {
						File f = fc.getSelectedFile();
						new SSDOM().load(f.getPath());
			            }
					}
				});
			}
			setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
			pack();
			this.setSize(600, 400);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	  public void areAligned(Planet p1, Planet p2, Planet p3)
	  {
		  synchronized(m_rects)
		  {
		  m_rects.add(p1);
		  m_rects.add(p2);
		  m_rects.add(p3);
		  }
	  }

	  public void areRect(Planet p1, Planet p2, Planet p3)
	  {
		  /*synchronized(m_rects)
		  {
		  m_rects.add(p1);
		  m_rects.add(p2);
		  m_rects.add(p3);
		  }*/
	  }
	
}
